﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Diagrams.Core;
using Telerik.Windows.Controls.Diagrams;
using Telerik.Windows.Controls;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			DiagramConstants.MinimumZoom = 0.1;
			InitializeComponent();
			this.diagram.Loaded += diagram_Loaded;
			this.BindGraphSource();
		}

		void diagram_Loaded(object sender, RoutedEventArgs e)
		{
            this.AddCustomConnector();
			this.PrepareAndLayout();
		}

		private void BindGraphSource()
		{
			GraphSource source = new GraphSource();
			OrgItem rootItem = new OrgItem() { Label = "CEO" };
			source.AddNode(rootItem);
			for (int i = 0; i < 2; i++)
			{
				OrgItem child = new OrgItem() { Label = "Manager " + i };
				source.AddNode(child);
				source.AddLink(new OrgLink(rootItem, child));
				for (int j = 0; j < 2; j++)
				{
					OrgItem subchild = new OrgItem() { Label = "Team LEad" + i + "." + j };
					source.AddNode(subchild);
					source.AddLink(new OrgLink(child, subchild));
				}
			}
			this.diagram.GraphSource = source;
		}

		private void RadButton_Click(object sender, RoutedEventArgs e)
		{
			this.PrepareAndLayout();
		}

		private void AddCustomConnector()
		{
			foreach (var item in this.diagram.Shapes)
			{
				var connector = new RadDiagramConnector() { Offset = new Point(0.2, 1) };
				connector.Name =  "aa" + DateTime.Now.Millisecond;
				item.Connectors.Add(connector);

                var connector2 = new RadDiagramConnector() { Offset = new Point(0.2, 0) };
                connector.Name = "bb" + DateTime.Now.Millisecond;
                item.Connectors.Add(connector2);
			}
		}

		private void PrepareAndLayout()
		{			
			TreeLayoutSettings settings = new TreeLayoutSettings()
			{
				TreeLayoutType = TreeLayoutType.TreeDown,
				VerticalDistance = 100,
				UnderneathHorizontalOffset = 50,
				UnderneathVerticalTopOffset = 50,
				UnderneathVerticalSeparation = 60
			};
			settings.Roots.Add(this.diagram.Shapes[0]);
			OrgTreeRouter router = new OrgTreeRouter()
			{
				TreeLayoutType = TreeLayoutType.TreeDown,
				ConnectionOuterSpacing = 20,
			};
			this.diagram.RoutingService.Router = router;
			this.diagram.Layout(LayoutType.Tree, settings);
		}
		
	}
}
